// SimpleBug.java for SimpleSwarmBug2
// Defines the class for our SimpleBug agents/

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;
import swarm.space.Grid2dImpl;
import swarm.gui.Raster;

import swarm.objectbase.VarProbe;
import swarm.objectbase.MessageProbe;
import swarm.objectbase.EmptyProbeMapImpl;
import swarm.objectbase.ProbeMap;
import swarm.objectbase.ProbeLibrary;
import swarm.objectbase.ProbeLibraryImpl;
import swarm.objectbase.EmptyProbeMapImpl;

public class TargetBug extends Agent
{
    static final boolean randomRemove=true;
    static final double removeProbability=0.01;
    
    public TargetBug(Zone aZone, Grid2dImpl targetSpace, int X, int Y, int dir, int bNum, ModelSwarm mSwarm) {

        super(aZone, X, Y, dir, bNum, mSwarm, targetSpace, (byte)150);
        
  EmptyProbeMapImpl probeMapTargetBug = new EmptyProbeMapImpl(aZone, getClass()); 

  probeMapTargetBug.addProbe(probeVariable("xPos"));
  probeMapTargetBug.addProbe(probeVariable("yPos"));
  probeMapTargetBug.addProbe(probeVariable("agentNumber"));
  
  
  Globals.env.probeLibrary.setProbeMap$For(probeMapTargetBug,getClass());
        
                
    }

VarProbe probeVariable (String name)
{
    VarProbe varProbe = null;
    Class baseClass = super.getClass();

    do {
        varProbe =
            Globals.env.probeLibrary.getProbeForVariable$inClass
            (name, baseClass);
        baseClass = baseClass.getSuperclass ();
    } while (varProbe == null && baseClass != null);
    return varProbe;
} 



public void uniformMotion(){

    myBugSpace.putObject$atX$Y(null, xPos, yPos);
       
    int newX=xPos, newY=yPos;
    
    switch(direction) {
        case 1 : newY--;   // N
                   break;
        case 3 : newX--;   // E
                   break; 
        case 2 : newY++;   // S
                   break;
        case 4 : newX++;   // W
                   break; 
        default  : System.out.println("No movement occurred in fnct uniformMotion()");
                   break;
    }
    
    xPos = (newX + worldXSize) % worldXSize;
    yPos = (newY + worldYSize) % worldYSize;

    // If there is another target at the new position, do not move.
    
    if(!((modelSwarm.getTargetSpace()).getObjectAtX$Y(xPos,yPos) instanceof TargetBug)) {
        myBugSpace.putObject$atX$Y(this, xPos, yPos);
        
        
    // InterCeption detection --- DEPENDS CRITICALLY ON THE ACTIVATION SCHEDULE!! HERE AGENT MOVES THEN TARGET!
        
	if((modelSwarm.getWorld()).getObjectAtX$Y(xPos,yPos) instanceof SimpleBug){
	                    
	    // reportInterception has to go through modelSwarm because this Target object
	    // has to be removed. The intercepting SimpleBug is notified through modelSwarm.

	    modelSwarm.reportInterception(xPos,yPos);
        }
    
    }
    else if(randomRemove && (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0,1) <= removeProbability)) 
        modelSwarm.removeTarget(this);
 

// Method to report the bug's position to the console.

}

public void reportPosition() {
    
    System.out.println("Bug " + agentNumber + " is at " + xPos + ", " + yPos);



}

  public Object setBugColor(byte c) { 
    agentColor = c; 
    return this; 
  }

  public Object drawSelfOn (Raster r) {
    r.drawPointX$Y$Color (xPos, yPos, agentColor);
    return this;
  }

}
